﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace WifiAutomation {

    class Action {

        String action;
        String value;

        public static String RUN = "Run";
        public static String VOLUME = "Volume";
        public static String KILL = "Kill";

        public static Dictionary<String, String> actions() {
            Dictionary<String, String> actions = new Dictionary<String, String>();
            actions.Add(RUN, "Run a program");
            actions.Add(KILL, "Stop a program");
            actions.Add(VOLUME, "Change system volume");
            return actions;
        }

        public Action(String action, String value) {
            this.action = action;
            this.value = value;
        }

        public Action(XmlTextReader reader) {
            while (reader.Read()) {
                switch (reader.NodeType) {
                    case XmlNodeType.Element:
                        if (reader.Name == "type")
                            action = reader.ReadString();
                        if (reader.Name == "value")
                            value = reader.ReadString();
                        break;
                    case XmlNodeType.EndElement:
                        if (reader.Name == "action")
                            return;
                        break;
                }
            }
        }

        public void writeTo(System.Xml.XmlTextWriter writer) {
            writer.WriteStartElement("action");
            writer.WriteElementString("type", action.ToString());
            writer.WriteElementString("value", value);
            writer.WriteEndElement();
        }

        public override String ToString() {
            return action + "\t" + value;
        }

        public void setValue(String value) {
            this.value = value;
        }

        public void setAction(String action) {
            this.action = action;
        }

        public String getAction() {
            return action;
        }

        public String getValue() {
            return value;
        }
    }
}
