﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace WifiAutomation {
    internal class Profile {

        public List<Action> actions = new List<Action>();
        String name;

        public Profile(String name) {
            this.name = name;
        }

        public Profile(XmlTextReader reader) {
            while (reader.Read()) {
                switch (reader.NodeType) {
                    case XmlNodeType.Element:
                        if (reader.Name == "name")
                            name = reader.ReadString();
                        if (reader.Name == "action")
                            actions.Add(new Action(reader));
                        break;
                    case XmlNodeType.EndElement:
                        if (reader.Name == "profile")
                            return;
                        break;
                }
            }
        }

        public void add(Action action) {
            actions.Add(action);
        }

        public void writeTo(XmlTextWriter writer) {
            writer.WriteStartElement("profile");
            writer.WriteElementString("name", name);
            foreach (Action action in actions) {
                action.writeTo(writer);
            }
            writer.WriteEndElement();
        }

        public override String ToString() {
            return name;
        }

        internal void setName(String name) {
            this.name = name;
        }
    }
}
